/*
Vilistextum v2.22
Copyright (C) 2001 Patric Mller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

/* 
 * Vilistextum v2.22
 *
 * history:
 * v0.1 ??.??.???? : lost due Harddisk-Crash
 * v1.x 26.04.1998 : variable width,
 *                   italic, underline, bold
 *                   HR implemented
 * v2.x 13.06.98   : UL, LI implemented
 *      21.06.98   : modified interface
 *      25.06.98   : fixed problem with paragraph-breaking & SGML entities
 *      27.06.98   : LI fixed, implemented IMAGE
 *      28.06.98   : HR: WIDTH, ALIGN,
 *                   DL, DT, DD,
 *                   PRE, TABLE (sort of),
 *                   EM, STRONG implemented
 *      15.07.98   : $91,$92,$93,$94 --> `,',","
 *      26.07.98   : fixed a bug with
 *                   get_attr(): got confused over empty attributs
 *                               <HR NOSHADE>
 *                   paragraph handling: got screwed up if there were
 *                                       only <p>s, but not </p>s
 *      28.07.98   : added "& " for those who don't know &amp;
 *      18.09.98   : added CODE
 *                   added all &xxx;
 *                   added "&#38;"  '&', "&#62;"  '<', "&#60;"  '>'
 *      02.02.99   : added "&#160;" ' ', "&#169;" '', "&#180;" '`',
 *                         "&#228;" '', "&#252;" '', "&#246;" '',
 *                         "&#196;" '', "&#220;" '', "&#214;" '',
 *                         "&#223;" 'ss',
 *                   added RIGHT, /RIGHT,
 *                   added all "&#xxx;",
 *                   AREA, /AREA, MAP, /MAP,
 *                   !--
 *      27.02.99   : better implementation of BLOCKQUOTE
 *      09.03.99   : fixed bug which read wrong breite
 *      01.09.00   : added support for palm, added &#145-152
 *      30.10.00   : added "&#34;"
 *      10.11.00   : bad bug, Remember Character!=String,
 *                   convert B,I,U to ASCII-Characters,
 *                   ignoring now SCRIPT and SUP
 *      30.01.01   : added all special microsoft ascii char between 127-160,
 *                   no more warnings with wall
 *      14.02.01   : better command parsing (still no getopt)
 *                   added microsoft entities
 *      20.02.01   : unknown &#xxx; will be printed as text
 *                   microsoft_entities broke latin1 regognition (how appropriate)
 *                   errorlevel introduced
 *      20.02.01   : SCRIPT was not implemented
 *                   Default Image text editable
 *                   Comment !-- was buggy, stopped at just a >
 *                   get_attr eats whitespace now
 *      22.02.01   : added --remove-empty-alt
 *                   OL are not numbered but get a "-"
 *      26.02.01   : broken entities (&nbsp) are recognized
 *                   removed a small table bug
 *                   no longer gets confused about something like <</b>
 *      09.03.01   : getopt implemented
 *                   added some xhtml like empty tags <br/> <hr/>,
 *                   whitespace error in get_attr fixed
 *                   html 3.2 spec misunderstood, div needs linebreak
 *      08.04.01   : fixed friss_kommentar
 *      09.04.01   : first public release
 *
 * TO DO
 * -----
 * check OL vs UL
 * align_nr stimmt was nicht
 *
 */

#include <unistd.h>
#define _GNU_SOURCE
#include <getopt.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

//#define debug 
//#define center_debug
//#define proc_debug 
//#define attr_debug 

//#define wort_ende_debug 
//#define default_debug 

#define DEF_STR_LEN 30000

FILE *in, *out;

int LEFT = 1,
  CENTER = 2,
  RIGHT  = 3;

int ch,
    breite=76,
    hr_breite=76,
    paragraph=0,
    leerer_paragraph=0,

    palm = 0, // wenn true, kein center und right fuer Zeile ausfuehren und escape sequence abschalten 
    convert_tags = 0, // falls true, werden Tags wie B,I in ASCII-Zeichen umgewandelt
  	errorlevel = 1 , // 0, no error; 1, missing entities; 2, missing tags
  	microsoft = 1 , // falls true, werden Characters im Bereich 128-159 in ASCII-Zeichen umgewandelt 
  	shrink_lines = 0, // maximal mal 2 leerzeichen
  	remove_empty_alt = 0, // entferne leere IMG ALT="" 

    align[256],
    align_nr=0,

    tab=4,         /* Tabulator Schrittweite */
    spaces=0,      /* Space einfgen bei Zeilenanfang */
    pre=0,         /* fuer PRE-Tag */
	  nooutput=0,    /* fr SCRIPT u..: keine Ausgabe */
  	orderedlist=0, /* OL */

    div_test=0;

char bullet_style=' ',
     wort[DEF_STR_LEN],

     attr_name[DEF_STR_LEN], /* Attribut Name innerhalb eines HTML-TAGs */
     attr_ctnt[DEF_STR_LEN], /* Attribut Inhalt innerhalb eines HTML-TAGs */

     str[DEF_STR_LEN];

char zeile[DEF_STR_LEN];
int  zeilen_len=0,    /* scheinbare Lnge der Zeile */
     zeilen_len_old=0,
     zeilen_pos=0,    /* wahre Lnge der Zeile */
     wort_len=0,      /* scheinbare Lnge des Worts */
     wort_pos=0;      /* wahre Lnge des Worts */

char *default_image="Image"; // Defaultstring fr IMG ohne ALT

void status();
int get_attr();
void start_p();
void uppercase_str(char *);

/* ------------------------------------------------ */

void center_zeile()
{
  int i,j;
#ifdef proc_debug
  printf("\ncenter_zeile()\n");
#endif

  if (!palm)
  {
    if (zeilen_len!=0)
    {
      j=(breite-zeilen_len)/2;

#ifdef center_debug
      printf(" center-zeile; len: %d; j: %d\n",zeilen_len,j);
      printf(" %s\n",zeile);
#endif
      for (i=zeilen_pos+j+2; i>=0; i--)
      {
#ifdef center_debug
	printf(" %c",zeile[i]);
#endif
	zeile[i+j]=zeile[i];
      }
      for (i=0; i<j; i++) { zeile[i]=' '; }
#ifdef center_debug
      printf(" \n%s\n\n",zeile);
      printf(" --------------------------------------------------\n");
#endif
    }
#ifdef proc_debug
  printf("center_zeile() ende\n");
#endif
  }
} /* end center_zeile */

/* ------------------------------------------------ */

void right_zeile()
{
  int i,j;
#ifdef proc_debug
  printf("\nright_zeile()\n");
#endif

  if (!palm)
  {
    if (zeilen_len!=0)
    {
      j=breite-zeilen_len;

#ifdef right_debug
      printf(" right-zeile; len: %d; j: %d\n",zeilen_len,j);
      printf(" %s\n",zeile);
#endif
      for (i=zeilen_pos+j+2; i>=0; i--)
      {
#ifdef right_debug
	printf(" %c",zeile[i]);
#endif
	zeile[i+j]=zeile[i];
      }
      for (i=0; i<j; i++) { zeile[i]=' '; }
#ifdef right_debug
      printf(" \n%s\n\n",zeile);
      printf(" --------------------------------------------------\n");
#endif
    }
  }
#ifdef proc_debug
  printf("right_zeile() ende\n");
#endif
} /* end right_zeile */

/* ------------------------------------------------ */

// return true, if z is all spaces or nonbreakable space
int only_spaces(char *z)
{
  int len=strlen(z);
	int i, ret=1;
	unsigned char j;

	for (i=0; i<len; i++) { j=z[i]; ret = (ret && ((j==' ')||(j==160))); }
	return(ret);
} // end only_spaces

/* ------------------------------------------------ */

void print_zeile()
{
#ifdef proc_debug
  printf("\nprint_zeile()\n");
  printf("align[align_nr]: %d\n", align[align_nr]);
#endif

	if ((shrink_lines) && only_spaces(zeile)) 
	{ 
    zeile[0]='\0';
		//zeilen_len_old=zeilen_len;
    zeilen_len=0; zeilen_pos=0;
	}

  if (!((zeilen_len==0) && (zeilen_len_old==0)))
  {
    if (align[align_nr]==LEFT)   {}
    if (align[align_nr]==CENTER) { center_zeile(); }
    if (align[align_nr]==RIGHT)  { right_zeile(); }

    if (!nooutput) { fprintf(out,"%s\n",zeile); }
#ifdef debug		
    else { printf("keine ausgabe von %s\n", zeile); }
#endif

    zeile[0]='\0';
    zeilen_len_old=zeilen_len;
    zeilen_len=0; zeilen_pos=0;
  }
#ifdef proc_debug
  printf("print_zeile() ende\n");
#endif
} /* end print_zeile */

/* ------------------------------------------------ */

void quit()
{
  if (zeile[0]!='\0') { print_zeile(); }
  fclose(in);
  fclose(out);
  exit(0);
} /* end quit */

/* ------------------------------------------------ */

void push_align(int a)
{
#ifdef proc_debug
  printf("push_align()\n");
#endif
  align_nr++;
	//	if (div_test!=0) { align[align_nr]=div_test; } else { 
	align[align_nr]=a; //}
}

void pop_align()
{
  if (align_nr==0) { if (errorlevel>=5) { printf("Fehler: align_nr=0\n");} }
  else { align_nr--; }
	//printf("align_nr %d\n", align_nr);
#ifdef proc_debug
  printf("pop_align()\n");
#endif
}

/* ------------------------------------------------ */

void status()
{
printf(" paragraph: %d; align_nr: %d; div_test: %d; align[align_nr]: %d; z_o: %d\n",paragraph, align_nr, div_test, align[align_nr], zeilen_len_old);

#ifdef wort_ende_debug
  printf(" zeile: %s\n",zeile);
  printf(" wort: %s\n",wort);
	printf(" nooutput:   %d\n", nooutput);
  printf(" zeilen_len: %d ; wort_len: %d\n",zeilen_len,wort_len);
  printf(" zeilen_pos: %d ; wort_pos: %d\n",zeilen_pos,wort_pos);
#endif
}

/* ------------------------------------------------ */

void zeile_plus_wort(char *s, int wl, int wp)
{
  int i=zeilen_pos,
      j=0;
#ifdef proc_debug
  printf("\nzeile_plus_wort()\n");
#endif

  while (i<zeilen_pos+wp) { zeile[i] = s[j]; j++; i++; }
  zeile[i] = '\0';
  zeilen_len += wl; zeilen_pos += wp;
#ifdef proc_debug
  printf("zeile_plus_wort() ende\n");
#endif
} /* end zeile_plus_wort */

/* ------------------------------------------------ */

void wort_plus_string_nocount(char *s)
{
  int len=strlen(s),
      i=wort_pos,
      j=0;
#ifdef proc_debug
  printf("\nwort_plus_string_nocount()\n");
#endif

  if (!palm)
  {
    while (i<wort_pos+len) { wort[i] = s[j]; j++; i++; }
    wort[i] = '\0';
    wort_pos += len;
  }

#ifdef proc_debug
  printf("wort_plus_string_nocount() ende\n");
#endif
} /* end wort_plus_string_nocount */

/* ------------------------------------------------ */

void wort_plus_string(char *s)
{
  int len=strlen(s),
      i=wort_pos,
      j=0;
#ifdef wort_ende_debug
  printf("\nwort_plus_string()\n");
#endif
#ifdef wort_ende_debug
  printf("s: %s\n", s);
#endif

  while (i<wort_pos+len) { wort[i] = s[j]; j++; i++; }
  wort[i] = '\0';
  wort_pos += len; wort_len += len;

#ifdef proc_debug
  printf("wort_plus_string() ende\n");
#endif
} /* end wort_plus_string */

/* ------------------------------------------------ */

void wort_plus_ch(c)
{

#ifdef default_debug
  printf("==wort_plus_ch(%d)\n", c);
#endif
  wort[wort_pos++] = c;
  wort_len++;
} /* end wort_plus */

/* ------------------------------------------------ */

void wort_ende()
{
  int i=0;
#ifdef proc_debug
    printf("wort_ende()\n");
#endif
  if (wort_len > 0)
  {
    wort[wort_pos] = '\0';

    if (zeilen_len+wort_len+1 > breite)
    {
#ifdef wort_ende_debug
      printf(" z0: zeilen_len: %d\n",zeilen_len);
      printf(" z0: zeilen_pos: %d\n",zeilen_pos);
#endif
      print_zeile();
      i=0;
      while (i<spaces) { zeile_plus_wort(" ",1,1); i++; }
			if (orderedlist>0) { zeile_plus_wort(" ",1,1); }
      zeile_plus_wort(wort, wort_len, wort_pos);
    }
    else if (zeilen_len != 0)
    {
#ifdef wort_ende_debug
      printf(" z1: zeilen_len: %d ; wort_len %d \n",zeilen_len, wort_len);
      printf(" z1: zeilen_pos: %d ; wort_pos %d\n",zeilen_pos, wort_pos);
#endif
			// Leerzeichen + Wort
      zeile_plus_wort(" ",1,1); zeile_plus_wort(wort,wort_len, wort_pos);
    }
    else /* zeilen_len==0 => neuer Paragraphenanfang */
    {
#ifdef wort_ende_debug
      printf(" z2: zeilen_len: %d\n",zeilen_len);
      printf(" z2: zeilen_pos: %d\n",zeilen_pos);
#endif
      i=0;
      while (i<spaces) { zeile_plus_wort(" ",1,1); i++; }
			if (orderedlist>0) { zeile_plus_wort(" ",1,1); }
      zeile_plus_wort(wort,wort_len, wort_pos);
    }
    wort_pos = 0;
    wort_len = 0;
    /* if (zeilen_len==0) { leerer_paragraph++; } */
  }

#ifdef proc_debug
  printf("wort_ende() ende\n");
#endif
} /* end wort_ende */

/* ------------------------------------------------ */

void line_break()
{
  wort_ende();
  print_zeile();
} /* end line_break */

/* ------------------------------------------------ */

void paragraphen_ende()
{
  if (paragraph!=0)
  {
#ifdef proc_debug
    printf("paragraph_ende()\n");
    printf("zeilen_len: %d\n", zeilen_len);
#endif
    line_break();
    print_zeile();
    paragraph--;

    pop_align();
  }
#ifdef proc_debug
  printf("paragraphen_ende() ende\n");
#endif
} /* end paragraphen_ende */

/* ------------------------------------------------ */

void neuer_paragraph()
{
#ifdef proc_debug
  printf("neuer_paragraph()\n");
#endif
  if (paragraph!=0) { paragraphen_ende(); }
  line_break();
  print_zeile();
  paragraph++;
  /* leerer_paragraph--; */
#ifdef proc_debug
  printf("neuer_paragraph() ende\n");
#endif
} /* end neuer_paragraph */

/* ------------------------------------------------ */

void hr()
{
  int i, hr_width=hr_breite-4, hr_align=CENTER;
#ifdef proc_debug
  printf("hr()\n");
#endif
  while (ch!='>')
  {
    ch=get_attr();
#ifdef attr_debug
    printf(" HR-Attr: %s; Inhalt: %s#\n",attr_name,attr_ctnt);
#endif
    uppercase_str(attr_name);
    if (strcmp("ALIGN", attr_name)==0)
    {
      uppercase_str(attr_ctnt);
      if (strcmp("LEFT", attr_ctnt)==0) { hr_align=LEFT;   }
      else if (strcmp("CENTER",  attr_ctnt)==0) { hr_align=CENTER; }
      else if (strcmp("RIGHT",   attr_ctnt)==0) { hr_align=RIGHT;  }
      else if (strcmp("JUSTIFY", attr_ctnt)==0) { hr_align=LEFT;  }			
      else { if (errorlevel>=2) { printf("Kein LEFT|CENTER|RIGHT gefunden!\n");} }
    }
    else if (strcmp("WIDTH", attr_name)==0)
    {
      i=strlen(attr_ctnt);
      if (attr_ctnt[i-1]=='%') {
        attr_ctnt[i-1] = '\0';
        hr_width = atoi(attr_ctnt);
        if (hr_width==100) { hr_width = hr_breite-4; }
        else { hr_width = hr_breite*hr_width/100; }
      } else {
        hr_width = atoi(attr_ctnt)/8;
        if (hr_width>hr_breite-4) { hr_width = hr_breite-4; }
      }
    }
  }

  neuer_paragraph();
  push_align(hr_align);
  for (i=0; i<hr_width; i++) { wort_plus_string("-"); }
  paragraphen_ende();
#ifdef proc_debug
  printf("hr() ende\n");
#endif
} /* end hr */

/* ------------------------------------------------ */

int uppercase(c)
{
  if ((c>='a') && (c<='z')) { c=toupper(c); }
  return c;
} /* end uppercase */

/* ------------------------------------------------ */

void uppercase_str(char *s)
{
  int i=0;
#ifdef proc_debug
  printf("uppercase()\n");
#endif
#ifdef proc_debug
  printf("%s -> ", s);
#endif
  while(s[i]!='\0') { s[i++]=uppercase(s[i]); }

#ifdef proc_debug
  printf("%s\n", s);
  printf("uppercase_str() ende\n");
#endif
} /* end uppercase_str */

/* ------------------------------------------------ */

int read_char()
{
  int c;
  if ((c=fgetc(in))==EOF)
  { quit(); return(0); }
  else
  {
    return c;
  }
} /* end read_char */

/* ------------------------------------------------ */

// set back stream p characters
void goback_char(int p)
{
	fseek(in, -p, SEEK_CUR);
} // end goback_char

/* ------------------------------------------------ */

int check_style()
{
  while (ch!='>')
  {
    ch=get_attr();
#ifdef debug
    printf("checkstyle; attr: %s; Inhalt: %s#\n",attr_name,attr_ctnt);
#endif
    if (strcmp("TYPE", attr_name)==0)
    {
      if (strcmp("disc", attr_ctnt)==0)   { return '*'; }
      if (strcmp("square", attr_ctnt)==0) { return '+'; }
      if (strcmp("circle", attr_ctnt)==0) { return 'o'; }
    }
  }
  return 0;
} /* end check_style */

/* ------------------------------------------------ */

void start_uls()
{
  //int ret;
#ifdef proc_debug
  printf("start_uls()\n");
#endif

  push_align(LEFT);
/*  ret=check_style();
  if (ret==0)
  {*/
    if (bullet_style==' ') { bullet_style='*'; }
    else if (bullet_style=='*') { bullet_style='o'; }
    else if (bullet_style=='o') { bullet_style='+'; }
		else if (bullet_style=='+') { bullet_style='#'; }
		else if (bullet_style=='#') { bullet_style='@'; }

/*  } else {
    bullet_style=ret;
  }*/
  spaces += tab;
#ifdef proc_debug
  printf("start_uls() ende\n");
#endif
} /* end start_uls */

void end_uls()
{
  spaces -= tab;
  line_break();
	if (bullet_style=='@') { bullet_style='#'; }
  else if (bullet_style=='#') { bullet_style='+'; }
  else if (bullet_style=='+') { bullet_style='o'; }
  else if (bullet_style=='o') { bullet_style='*'; }
  else if (bullet_style=='*') { bullet_style=' '; }

  pop_align();
}

/* ------------------------------------------------ */

void start_ols()
{
	start_uls();
	//	spaces+=2; orderedlist++;
} // end start_ols

/* ------------------------------------------------ */

void end_ols()
{
	end_uls();
	//	spaces-=2; orderedlist--;
} // end end_ols

/* ------------------------------------------------ */

void start_lis()
{
  spaces-=2;
  line_break();

  
	//wort_plus_ch(bullet_style);

	if (orderedlist>0) { wort_plus_string("-"); }
	else  { wort_plus_ch(bullet_style); }

  wort_ende();
  spaces+=2;
} /* end start_lis */

/* ------------------------------------------------ */


int definition_list=0;
void end_dd();

// Definition List
void start_dl()
{
	end_dd();
	start_p();
} // end start_dl

void end_dl()
{
	paragraphen_ende();

	end_dd();
} // end_dl

// Definition Title
void start_dt()
{	
	end_dd();
	
	line_break();
} // end start_dt

void end_dt()
{
} // end_dt

// Definition Description
void start_dd()
{
	end_dd();

	line_break(); 
	spaces+=tab; 

	definition_list=1;
} // end 

void end_dd()
{
	if (definition_list==1) 
	{
		spaces-=tab;
		definition_list=0;
	}
} // end_dd


/* ------------------------------------------------ */

/* used when there's only the align-attribut to be checked */
void check_for_center()
{
#ifdef proc_debug
  printf("check_for_center()\n");
#endif
  while (ch!='>')
  {
    ch=get_attr();
#ifdef debug
    printf(" Attr: %s; Inhalt: %s#\n",attr_name,attr_ctnt);
#endif
    uppercase_str(attr_name);
    if (strcmp("ALIGN", attr_name)==0)
    {
      uppercase_str(attr_ctnt);
      if (strcmp("LEFT",   attr_ctnt)==0) { push_align(LEFT);   }
      else if (strcmp("CENTER", attr_ctnt)==0) { push_align(CENTER); }
      else if (strcmp("RIGHT",  attr_ctnt)==0) { push_align(RIGHT);  }
      else if (strcmp("JUSTIFY", attr_ctnt)==0) { push_align(LEFT);  }		
      else { if (errorlevel>=2) { printf("Kein LEFT|CENTER|RIGHT gefunden!\n"); push_align(LEFT); } }
    } else {
      /* kein ALIGN gefunden */
      push_align(LEFT);
    }
  }

#ifdef proc_debug
  printf("check_for_center() ende\n");
#endif
} /* end check_for_center */

/* ------------------------------------------------ */

void start_p()
{
#ifdef proc_debug
  printf("\nstart_p()\n");
#endif
	push_align(LEFT);
  neuer_paragraph();
  check_for_center();
#ifdef proc_debug
  printf("start_p() ende\n");
#endif
} /* end start_p */

/* ------------------------------------------------ */

void start_div(int a)
{
#ifdef proc_debug
  printf("start_div()\n"),
#endif
		//  paragraphen_ende();

	line_break();

  if (a!=0) { div_test=a; push_align(div_test); }
  else { check_for_center(); }
#ifdef proc_debug
  printf("start_div() ende\n");
#endif
} /* end start_div */

/* ------------------------------------------------ */

void end_div()
{
#ifdef proc_debug
  printf("end_div()\n"),
#endif
  wort_ende();

  if (paragraph!=0) { paragraphen_ende(); }
  else { print_zeile(); }
  pop_align(); /* einer fr start_div */
  div_test = 0;
#ifdef proc_debug
  printf("end_div() ende\n");
#endif
} /* end_div */

/* ------------------------------------------------ */

void image()
{
  int found_alt=0;
#ifdef proc_debug
  printf("image()\n");
#endif
  while (ch!='>')
  {
    ch=get_attr();
    uppercase_str(attr_name);
    if (strcmp("ALT", attr_name)==0)
    {
			if (!(remove_empty_alt && (strcmp("", attr_ctnt)==0))) 
			{ 
				wort_plus_ch('['); wort_plus_string(attr_ctnt); wort_plus_ch(']');
			}
      found_alt=1;
    }
  }
  if (found_alt==0) { wort_plus_ch('['); wort_plus_string(default_image); wort_plus_ch(']'); }
#ifdef proc_debug
  printf("image() ende\n");
#endif
} /* end image */

/* ------------------------------------------------ */

void friss_kommentar()
{
	int c, dontquit=1;
	while (dontquit) 
	{
		c=read_char();
		if (c=='-')
		{
		  c=read_char();
			while (c=='-') 
		  {
			  c=read_char();
				if (c=='>') { dontquit=0; }
			}
		}
	}
	goback_char(1);
} // end friss_kommentar

/* ------------------------------------------------ */

void html_befehl()
{
  int i=0;

  ch = uppercase(read_char());

  /* Character != '/' bzw '!' und auch kein Buchstabe */
  /* => kein HTML-Befehl */
  if ((!isalpha(ch)) && (ch!='/') && (ch!='!'))
  {
    wort_plus_ch('<');
		goback_char(1);
    //if (ch==' ') { wort_ende(); }
    //else { wort_plus_ch(ch); }
    return;
  }

  while ((ch!='>') && (ch!=' ') && (ch!=13) && (ch!=10))
  {
    str[i++] = ch;
    if (i==DEF_STR_LEN) { printf("String zu lang!\n"); quit(); };
    ch = uppercase(read_char());
  }
  str[i] = '\0';
#ifdef debug
  printf("html_befehl: %s\n",str);
  status();
#endif

  if (strcmp("/HTML", str)==0) { quit(); }
  else if (strcmp("!DOCTYPE", str)==0) { while ((ch=read_char())!='>'); }

	// Linebreak
  else if (strcmp("BR", str)==0)  { line_break(); }
  else if (strcmp("BR/", str)==0) { line_break(); } // xhtml

  else if (strcmp("P", str)==0)  { start_p(); }
  else if (strcmp("/P", str)==0) { paragraphen_ende(); }
  else if (strcmp("BLOCKQUOTE", str)==0)  { start_p(); }
  else if (strcmp("/BLOCKQUOTE", str)==0) { paragraphen_ende(); }

#ifdef AMIGA
  else if (strcmp("B", str)==0)       { wort_plus_string_nocount("\033[1m");  }
  else if (strcmp("/B", str)==0)      { wort_plus_string_nocount("\033[22m"); }
  else if (strcmp("I", str)==0)       { wort_plus_string_nocount("\033[3m");  }
  else if (strcmp("/I", str)==0)      { wort_plus_string_nocount("\033[23m"); }
  else if (strcmp("U", str)==0)       { wort_plus_string_nocount("\033[4m");  }
  else if (strcmp("/U", str)==0)      { wort_plus_string_nocount("\033[24m"); }
  else if (strcmp("STRONG", str)==0)  { wort_plus_string_nocount("\033[1m");  }
  else if (strcmp("/STRONG", str)==0) { wort_plus_string_nocount("\033[22m"); }
  else if (strcmp("EM", str)==0)      { wort_plus_string_nocount("\033[3m");  }
  else if (strcmp("/EM", str)==0)     { wort_plus_string_nocount("\033[23m"); }
#else
  // Convert these Tags
  else if (strcmp("B", str)==0)       { if (convert_tags) { wort_plus_string("*"); } }
  else if (strcmp("/B", str)==0)      { if (convert_tags) { wort_plus_string("*"); } }
  else if (strcmp("I", str)==0)       { if (convert_tags) { wort_plus_string("/"); } }
  else if (strcmp("/I", str)==0)      { if (convert_tags) { wort_plus_string("/"); } }
  else if (strcmp("U", str)==0)       { if (convert_tags) { wort_plus_string("_"); } }
  else if (strcmp("/U", str)==0)      { if (convert_tags) { wort_plus_string("_"); } }
  else if (strcmp("STRONG", str)==0)  { if (convert_tags) { wort_plus_string("*"); } }
  else if (strcmp("/STRONG", str)==0) { if (convert_tags) { wort_plus_string("*"); } }
  else if (strcmp("EM", str)==0)      { if (convert_tags) { wort_plus_string("/"); } }
  else if (strcmp("/EM", str)==0)     { if (convert_tags) { wort_plus_string("/"); } }
#endif

  else if (strcmp("TITLE", str)==0)  { push_align(LEFT); neuer_paragraph(); }
  else if (strcmp("/TITLE", str)==0) { paragraphen_ende(); print_zeile(); }

  /* headings */
  else if (strcmp("H1", str)==0)  { start_p();          }
  else if (strcmp("/H1", str)==0) { paragraphen_ende(); }
  else if (strcmp("H2", str)==0)  { start_p();          }
  else if (strcmp("/H2", str)==0) { paragraphen_ende(); }
  else if (strcmp("H3", str)==0)  { start_p();          }
  else if (strcmp("/H3", str)==0) { paragraphen_ende(); }
  else if (strcmp("H4", str)==0)  { start_p();          }
  else if (strcmp("/H4", str)==0) { paragraphen_ende(); }
  else if (strcmp("H5", str)==0)  { start_p();          }
  else if (strcmp("/H5", str)==0) { paragraphen_ende(); }
  else if (strcmp("H6", str)==0)  { start_p();          }
  else if (strcmp("/H6", str)==0) { paragraphen_ende(); }

  else if (strcmp("HR", str)==0)  { hr(); }
  else if (strcmp("HR/", str)==0) { hr(); } // xhmtl


  else if (strcmp("UL", str)==0)  { start_uls(); }
  else if (strcmp("/UL", str)==0) { end_uls(); return; }
  else if (strcmp("LI", str)==0)  { start_lis(); }
  else if (strcmp("OL", str)==0)  { start_ols(); }
  else if (strcmp("/OL", str)==0) { end_ols(); }

  else if (strcmp("DIV", str)==0)      { start_div(0); }
  else if (strcmp("/DIV", str)==0)     { end_div(); }
  else if (strcmp("CENTER", str)==0)   { start_div(CENTER); }
  else if (strcmp("/CENTER", str)==0)  { end_div(); }
  else if (strcmp("RIGHT", str)==0)    { start_div(RIGHT); }
  else if (strcmp("/RIGHT", str)==0)   { end_div(); }

  else if (strcmp("IMG", str)==0)  { image(); }

  else if (strcmp("TABLE", str)==0)    { /*start_p();*/ push_align(LEFT); neuer_paragraph(); }
  else if (strcmp("/TABLE", str)==0)   { paragraphen_ende(); }
  else if (strcmp("TD", str)==0)       { wort_plus_ch(' '); }
  else if (strcmp("/TD", str)==0)      {}
  else if (strcmp("TH", str)==0)       {}
  else if (strcmp("/TH", str)==0)      {}
  else if (strcmp("TR", str)==0)       { line_break(); } // start_p(); 
  else if (strcmp("/TR", str)==0)      { /*paragraphen_ende();*/ }
  else if (strcmp("CAPTION", str)==0)  {}
  else if (strcmp("/CAPTION", str)==0) {}

  else if (strcmp("PRE", str)==0)   { start_p();  pre=1; }
  else if (strcmp("/PRE", str)==0)  { paragraphen_ende(); pre=0; }

  else if (strcmp("DL", str)==0)  { start_dl();} // Definition List
  else if (strcmp("/DL", str)==0) { end_dl(); }
  else if (strcmp("DT", str)==0)  { start_dt(); } // Definition Title
  else if (strcmp("/DT", str)==0) { end_dt(); }
  else if (strcmp("DD", str)==0)  { start_dd(); } // Definition Description
  else if (strcmp("/DD", str)==0) { end_dd(); }

  else if (strcmp("SCRIPT", str)==0)  { wort_ende(); print_zeile(); nooutput = 1; }
  else if (strcmp("/SCRIPT", str)==0) { wort_ende(); print_zeile(); nooutput = 0; }
  else if (strcmp("STYLE", str)==0)   { wort_ende(); print_zeile(); nooutput = 1; }
  else if (strcmp("/STYLE", str)==0)  { wort_ende(); print_zeile(); nooutput = 0; }


  /* those tags are ignored */
  else if (strcmp("HTML", str)==0)      {}
  else if (strcmp("BASE", str)==0)      {}
  else if (strcmp("HEAD", str)==0)      {}
  else if (strcmp("/HEAD", str)==0)     {}
  else if (strcmp("BODY", str)==0)      {}
  else if (strcmp("/BODY", str)==0)     {}
  else if (strcmp("META", str)==0)      {}
  else if (strcmp("A", str)==0)         {}
  else if (strcmp("/A", str)==0)        {}
  else if (strcmp("FONT", str)==0)      {}
  else if (strcmp("/FONT", str)==0)     {}
  else if (strcmp("SAMP", str)==0)      {}
  else if (strcmp("/SAMP", str)==0)     {}
  else if (strcmp("CODE", str)==0)      {}
  else if (strcmp("/CODE", str)==0)     {}
  else if (strcmp("AREA", str)==0)      {}
  else if (strcmp("/AREA", str)==0)     {}
  else if (strcmp("MAP", str)==0)       {}
  else if (strcmp("/MAP", str)==0)      {}
  else if (strcmp("SUP", str)==0)       {}
  else if (strcmp("/SUP", str)==0)      {}
  else if (strcmp("FORM", str)==0)      {}
  else if (strcmp("/FORM", str)==0)     {}
  else if (strcmp("INPUT", str)==0)     {}
  else if (strcmp("ADDRESS", str)==0)   {}
  else if (strcmp("/ADDRESS", str)==0)  {}
  else if (strcmp("LINK", str)==0)      {}
  else if (strcmp("BASEFONT", str)==0)  {}
	else if (strcmp("TT", str)==0)        {}
	else if (strcmp("/TT", str)==0)       {}
  else if (strcmp("SUB", str)==0)       {}
  else if (strcmp("/SUB", str)==0)      {}
  else if (strcmp("NOSCRIPT", str)==0)  {}
  else if (strcmp("/NOSCRIPT", str)==0) {}
  else if (strcmp("SMALL", str)==0)     {}
  else if (strcmp("/SMALL", str)==0)    {}
    
  else if (strncmp("!--", str, 3)==0)  { friss_kommentar(); } /* Kommentar */

  else { if (errorlevel>=2) { printf("tag %s ignored!\n", str);} }

	//	printf("ch1: %c\n", ch);

  /* Attribute */
  while (ch!='>')
  {
#ifdef debug
    printf("%c", ch);
#endif
    ch = get_attr();
#ifdef debug
    printf("Attribut: %s; Inhalt: %s#\n",attr_name,attr_ctnt);
#endif
  }
	//	printf("\nch2: %c\n", ch);
} /* end html_befehl */

/* ------------------------------------------------ */

int get_attr()
{
  int i;
#ifdef proc_debug
  printf("get_attr()\n");
#endif

  attr_name[0] = '\0';
  attr_ctnt[0] = '\0';

  while ((isspace(ch)) && (ch!='>')) { ch=read_char(); }
  if (ch=='>') { return '>'; };

  /* Attribut Namen lesen */
  i=1;
  attr_name[0] = ch;

	while ((ch!='=') && (ch!='>'))
  { ch=read_char(); attr_name[i++] = ch; }
  attr_name[i-1] = '\0';
	
  if (ch=='>') { attr_ctnt[0]='\0'; return '>'; }

  /* Inhalt des Attributs */
	ch=read_char();
	// skip white_space
	while ((isspace(ch)) && (ch!='>')) { ch=read_char(); }

  if (ch=='"')
  {
		// ist vom typ alt="bla"
    i=0;
    ch=read_char();
    while(ch!='"') { attr_ctnt[i++] = ch; ch=read_char(); }
    attr_ctnt[i] = '\0';
    ch=read_char();
  }
  else
  {
		// ist vom typ alt=bla
    i=1;
    attr_ctnt[0] = ch;
    while ((ch!='>') && (!isspace(ch))) { ch=read_char(); attr_ctnt[i++] = ch; }
    attr_ctnt[i-1] = '\0';
  }
#ifdef attr_debug
  printf("Attribut: %s; Inhalt: %s#-#\n", attr_name, attr_ctnt);
#endif
#ifdef proc_debug
  printf("get_attr() ende\n");
#endif
  return ch;
} /* end get_attr */

/* ------------------------------------------------ */

int microsoft_entities(char *s)
{
	if (!microsoft) { return(0); }
	// Euro
	else if (strcmp("&#128;", s)==0)    { wort_plus_string("EUR"); }
	else if (strcmp("&euro;", s)==0)    { wort_plus_string("EUR"); }
	else if (strcmp("&#8364;", s)==0)   { wort_plus_string("EUR"); }

	// Single Low-9 Quotation Mark
	else if (strcmp("&#130;", s)==0)    { wort_plus_ch(','); }
	else if (strcmp("&sbquo;", s)==0)   { wort_plus_ch(','); }
	else if (strcmp("&#8218;", s)==0)   { wort_plus_ch(','); }

	else if (strcmp("&#131;", s)==0)    { wort_plus_ch('f'); }        // Latin Small Letter F With Hook
	else if (strcmp("&fnof;", s)==0)    { wort_plus_ch('f'); }        // Latin Small Letter F With Hook
	else if (strcmp("&#402;", s)==0)    { wort_plus_ch('f'); }        // Latin Small Letter F With Hook

	// Double Low-9 Quotation Mark
	else if (strcmp("&#132;", s)==0)    { wort_plus_string("\""); }
	else if (strcmp("&bdquo;", s)==0)   { wort_plus_string("\""); }
	else if (strcmp("&#8222;", s)==0)   { wort_plus_string("\""); }

	else if (strcmp("&#133;", s)==0)    { wort_plus_string("... "); } // Horizontal Ellipsis
	else if (strcmp("&hellip;", s)==0)  { wort_plus_string("... "); } // Horizontal Ellipsis
	else if (strcmp("&#8230;", s)==0)  { wort_plus_string("... "); } // Horizontal Ellipsis

	// Dagger
	else if (strcmp("&#134;", s)==0)    { wort_plus_string("/-"); }   
	else if (strcmp("&dagger;", s)==0)  { wort_plus_string("/-"); }
	else if (strcmp("&#8224;", s)==0)   { wort_plus_string("/-"); }

	// Double Dagger
	else if (strcmp("&#135;", s)==0)    { wort_plus_string("/="); }
	else if (strcmp("&Dagger;", s)==0)  { wort_plus_string("/="); }
	else if (strcmp("&#8225;", s)==0)   { wort_plus_string("/="); }

	// Modifier Letter Circumflex Accent
	else if (strcmp("&#136;", s)==0)    { wort_plus_ch('^'); }
	else if (strcmp("&circ;", s)==0)    { wort_plus_ch('^'); }
	else if (strcmp("&#710;", s)==0)    { wort_plus_ch('^'); }

	// Per Mille Sign
	else if (strcmp("&#137;", s)==0)    { wort_plus_string("O/oo"); }
	else if (strcmp("&permil;", s)==0)  { wort_plus_string("O/oo"); }
	else if (strcmp("&#8240;", s)==0)   { wort_plus_string("O/oo"); } 

	// Latin Capital Letter S With Caron
	else if (strcmp("&#138;", s)==0)    { wort_plus_ch('S'); }
	else if (strcmp("&Scaron;", s)==0)  { wort_plus_ch('S'); }
	else if (strcmp("&#352;", s)==0)    { wort_plus_ch('S'); }

	// Single Left-Pointing Angle Quotation Mark
	else if (strcmp("&#139;", s)==0)    { wort_plus_ch('<'); }
	else if (strcmp("&lsaquo;", s)==0)  { wort_plus_ch('<'); }
	else if (strcmp("&#8249;", s)==0)   { wort_plus_ch('<'); }

	// Latin Capital Ligature OE
	else if (strcmp("&#140;", s)==0)    { wort_plus_string("OE"); }  
	else if (strcmp("&OElig;", s)==0)   { wort_plus_string("OE"); }   
	else if (strcmp("&#338;", s)==0)    { wort_plus_string("OE"); }  

	// Z\/
	else if (strcmp("&#142;", s)==0)    { wort_plus_ch('Z'); }
	else if (strcmp("&#381;", s)==0)    { wort_plus_ch('Z'); }

	// Left Single Quotation Mark
	else if (strcmp("&#145;", s)==0)    { wort_plus_ch('`'); }
	else if (strcmp("&lsquo;", s)==0)   { wort_plus_ch('`'); }
	else if (strcmp("&#8216;", s)==0)   { wort_plus_ch('`'); }

	// Right Single Quotation Mark
	else if (strcmp("&#146;", s)==0)    { wort_plus_ch('\''); }
	else if (strcmp("&rsquo;", s)==0)   { wort_plus_ch('\''); }
	else if (strcmp("&#8217;", s)==0)   { wort_plus_ch('\''); }

	// Left Double Quotation Mark
	else if (strcmp("&#147;", s)==0)    { wort_plus_ch('"'); }
	else if (strcmp("&ldquo;", s)==0)   { wort_plus_ch('"'); }
	else if (strcmp("&#8220;", s)==0)   { wort_plus_ch('"'); }

	// Right Double Quotation Mark
	else if (strcmp("&#148;", s)==0)    { wort_plus_ch('"'); }
	else if (strcmp("&rdquo;", s)==0)   { wort_plus_ch('"'); }
	else if (strcmp("&#8221;", s)==0)   { wort_plus_ch('"'); }

	// Bullet
	else if (strcmp("&#149;", s)==0)    { wort_plus_ch('*'); }
	else if (strcmp("&bull;", s)==0)    { wort_plus_ch('*'); }
	else if (strcmp("&#8226;", s)==0)   { wort_plus_ch('*'); }

	// En Dash
	else if (strcmp("&#150;", s)==0)    { wort_plus_ch('-'); }
	else if (strcmp("&ndash;", s)==0)   { wort_plus_ch('-'); }
	else if (strcmp("&#8211;", s)==0)   { wort_plus_ch('-'); }

	// Em Dash
	else if (strcmp("&#151;", s)==0)    { wort_plus_string("--"); }
	else if (strcmp("&mdash;", s)==0)   { wort_plus_string("--"); }
	else if (strcmp("&#8212;", s)==0)   { wort_plus_string("--"); }

	// Small Tilde
	else if (strcmp("&#152;", s)==0)    { wort_plus_ch('~'); }
	else if (strcmp("&tilde;", s)==0)   { wort_plus_ch('~'); }
	else if (strcmp("&#732;", s)==0)    { wort_plus_ch('~'); } 

	// Trade Mark Sign
	else if (strcmp("&#153;", s)==0)    { wort_plus_string("[tm]"); }
	else if (strcmp("&trade;", s)==0)   { wort_plus_string("[tm]"); }
	else if (strcmp("&#8482;", s)==0)   { wort_plus_string("[tm]"); }

  // Latin Small Letter S With Caron
	else if (strcmp("&#154;", s)==0)    { wort_plus_ch('s'); }
	else if (strcmp("&scaron;", s)==0)  { wort_plus_ch('s'); }
	else if (strcmp("&#353;", s)==0)    { wort_plus_ch('s'); }

	// Single Right-Pointing Angle Quotation Mark
	else if (strcmp("&#155;", s)==0)    { wort_plus_ch('>'); }
	else if (strcmp("&rsaquo;", s)==0)  { wort_plus_ch('>'); }
	else if (strcmp("&#8250;", s)==0)   { wort_plus_ch('>'); }

	// Latin Small Ligature OE
	else if (strcmp("&#156;", s)==0)    { wort_plus_string("oe"); }
	else if (strcmp("&oelig;", s)==0)   { wort_plus_string("oe"); }
	else if (strcmp("&#339;", s)==0)    { wort_plus_string("oe"); }

	// z\/
	else if (strcmp("&#158;", s)==0)    { wort_plus_ch('z'); }
	else if (strcmp("&#382;", s)==0)    { wort_plus_ch('z'); }

	// Latin Capital Letter Y With Diaeresis 
	else if (strcmp("&#159;", s)==0)    { wort_plus_ch('Y'); }
	else if (strcmp("&Yuml;", s)==0)    { wort_plus_ch('Y'); }
	else if (strcmp("&#376;", s)==0)    { wort_plus_ch('Y'); }
	
	else { return(0); }

	return(1); // Microsoft entity found
} // end microsoft_entities

/* ------------------------------------------------ */

void microsoft_character(int c)
{
	switch (c)
	{
		// Microsoft...
	case 0x80: /* MICROSOFT EURO */
		wort_plus_string("EUR"); break;
		
	case 0x82: /* SINGLE LOW-9 QUOTATION MARK */
		wort_plus_ch(','); break;
	case 0x83: /* Latin Small Letter F With Hook */
		wort_plus_ch('f'); break;
	case 0x84: /* Double Low-9 Quotation Mark */
		wort_plus_string("\""); break;
	case 0x85: /* HORIZONTAL ELLIPSIS */
		wort_plus_string("..."); break;
	case 0x86: /* Dagger */
		wort_plus_string("/-"); break;
	case 0x87: /* Double Dagger */
		wort_plus_string("/="); break;
	case 0x88: /* Modifier Letter Circumflex Accent */
		wort_plus_ch('^'); break;
	case 0x89: /* Per Mille Sign */
		wort_plus_string("O/oo"); break;
	case 0x8a: /* Latin Capital Letter S With Caron */
		wort_plus_ch('S'); break;
	case 0x8b: /*  Single Left-Pointing Angle Quotation Mark */
		wort_plus_ch('<'); break;
	case 0x8c: /* Latin Capital Ligature OE */
		wort_plus_string("OE"); break;

	case 0x8e: /* Z\/ */
		wort_plus_ch('Z'); break;
		
	case 0x91: /* LEFT SINGLE QUOTATION MARK */
        wort_plus_ch('`'); break;
	case 0x92: /* RIGHT SINGLE QUOTATION MARK */
		wort_plus_ch('\''); break;
	case 0x93: /* LEFT DOUBLE QUOTATION MARK */
		wort_plus_ch('\"'); break;
	case 0x94: /* RIGHT DOUBLE QUOTATION MARK */
		wort_plus_ch('\"'); break;
	case 0x95: /* BULLET */
		wort_plus_ch('*'); break;
	case 0x96: /* EN DASH */
		wort_plus_ch('-'); break;
	case 0x97: /* EM DASH */
		wort_plus_string("--"); break;
	case 0x98: /* SMALL TILDE */
		wort_plus_ch('~'); break;
	case 0x99: /* TRADE MARK SIGN */
		wort_plus_string("[tm]"); break;
	case 0x9a: /* LATIN SMALL LETTER S WITH CARON */
		wort_plus_ch('s'); break;
	case 0x9b: /* SINGLE RIGHT-POINTING ANGLE QUOTATION MARK */
		wort_plus_ch('>'); break;
	case 0x9c: /* LATIN SMALL LIGATURE OE */
		wort_plus_string("oe"); break;
		
	case 0x9e: /* z\/ */
		wort_plus_ch('z'); break;
	case 0x9f: /* LATIN CAPITAL LETTER Y WITH DIAERESIS */
		wort_plus_ch('Y'); break;
	}
} // end microsoft_character

/* ------------------------------------------------ */

int entity_number(char *s)
{
	int number;

 	if ((s[0]=='&') && (s[1]=='#'))
	{
		s = s++; s=s++;
		//printf("%s %d \n", s, atoi(s));
		number = atoi(s);
		if (((number>=32) && (number<=127)) || ((number>=160) && (number<=255))) 
		{ 
			wort_plus_ch(number);
			return(1);
		}
	}
	return(0);
} // end entity_number

/* ------------------------------------------------ */

int latin1(char *str)
{
	if (strcmp("&quot;",      str)==0)    { wort_plus_ch('"'); }
	else if (strcmp("&;",     str)==0)    { wort_plus_ch('&'); } // for those brain damaged ones
	else if (strcmp("&amp;",  str)==0)    { wort_plus_ch('&'); }
	else if (strcmp("&gt;",   str)==0)    { wort_plus_ch('>'); }
	else if (strcmp("&lt;",   str)==0)    { wort_plus_ch('<'); }

	else if (strcmp("&nbsp;", str)==0)    { wort_plus_ch(160); } // no-break space 
	else if (strcmp("&iexcl", str)==0)    { wort_plus_ch(161); } // inverted exclamation mark 
	else if (strcmp("&cent;", str)==0)    { wort_plus_ch(162); } // cent sign 
	else if (strcmp("&pound;", str)==0)   { wort_plus_ch(163); } // pound sterling sign 
	else if (strcmp("&curren;", str)==0)  { wort_plus_ch(164); } // general currency sign 
	else if (strcmp("&yen;", str)==0)     { wort_plus_ch(165); } // yen sign 
	else if (strcmp("&brvbar;", str)==0)  { wort_plus_ch(166); } // broken (vertical) bar 
	else if (strcmp("&sect;", str)==0)    { wort_plus_ch(167); } // section sign 
	else if (strcmp("&uml;", str)==0)     { wort_plus_ch(168); } // umlaut (dieresis) 
	else if (strcmp("&copy;", str)==0)    { wort_plus_ch(169); } // copyright sign 
	else if (strcmp("&ordf;", str)==0)    { wort_plus_ch(170); } // ordinal indicator, feminine 
	else if (strcmp("&laquo;", str)==0)   { wort_plus_ch(171); } // angle quotation mark, left 
	else if (strcmp("&not;", str)==0)     { wort_plus_ch(172); } // not sign 
	else if (strcmp("&shy;", str)==0)     { wort_plus_ch(173); } // soft hyphen 
	else if (strcmp("&reg;", str)==0)     { wort_plus_ch(174); } // registered sign 
	else if (strcmp("&macr;", str)==0)    { wort_plus_ch(175); } // macron 
	else if (strcmp("&deg;", str)==0)     { wort_plus_ch(176); } // degree sign 
	else if (strcmp("&plusmn;", str)==0)  { wort_plus_ch(177); } // plus-or-minus sign 
	else if (strcmp("&sup2;", str)==0)    { wort_plus_ch(178); } // superscript two 
	else if (strcmp("&sup3;", str)==0)    { wort_plus_ch(179); } // superscript three 
	else if (strcmp("&acute;", str)==0)   { wort_plus_ch(180); } // acute accent 
	else if (strcmp("&micro;", str)==0)   { wort_plus_ch(181); } // micro sign 
	else if (strcmp("&para;", str)==0)    { wort_plus_ch(182); } // pilcrow (paragraph sign) 
	else if (strcmp("&middot;", str)==0)  { wort_plus_ch(183); } // middle dot 
	else if (strcmp("&cedil;", str)==0)   { wort_plus_ch(184); } // cedilla 
	else if (strcmp("&sup1;", str)==0)    { wort_plus_ch(185); } // superscript one 
	else if (strcmp("&ordm;", str)==0)    { wort_plus_ch(186); } // ordinal indicator, masculine 
	else if (strcmp("&raquo;", str)==0)   { wort_plus_ch(187); } // angle quotation mark, right 
	else if (strcmp("&frac14;", str)==0)  { wort_plus_ch(188); } // fraction one-quarter 
	else if (strcmp("&frac12;", str)==0)  { wort_plus_ch(189); } // fraction one-half 
	else if (strcmp("&frac34;", str)==0)  { wort_plus_ch(190); } // fraction three-quarters 
	else if (strcmp("&iquest;", str)==0)  { wort_plus_ch(191); } // inverted question mark 
	else if (strcmp("&Agrave;", str)==0)  { wort_plus_ch(192); } // capital A, grave accent 
	else if (strcmp("&Aacute;", str)==0)  { wort_plus_ch(193); } // capital A, acute accent 
	else if (strcmp("&Acirc;", str)==0)   { wort_plus_ch(194); } // capital A, circumflex accent 
	else if (strcmp("&Atilde;", str)==0)  { wort_plus_ch(195); } // capital A, tilde 
	else if (strcmp("&Auml;", str)==0)    { wort_plus_ch(196); } // capital A, dieresis or umlaut mark 
	else if (strcmp("&Aring;", str)==0)   { wort_plus_ch(197); } // capital A, ring 
	else if (strcmp("&AElig;", str)==0)   { wort_plus_ch(198); } // capital AE diphthong (ligature) 
	else if (strcmp("&Ccedil;", str)==0)  { wort_plus_ch(199); } // capital C, cedilla 
	else if (strcmp("&Egrave;", str)==0)  { wort_plus_ch(200); } // capital E, grave accent 
	else if (strcmp("&Eacute;", str)==0)  { wort_plus_ch(201); } // capital E, acute accent 
	else if (strcmp("&Ecirc;", str)==0)   { wort_plus_ch(202); } // capital E, circumflex accent 
	else if (strcmp("&Euml;", str)==0)    { wort_plus_ch(203); } // capital E, dieresis or umlaut mark 
	else if (strcmp("&Igrave;", str)==0)  { wort_plus_ch(204); } // capital I, grave accent 
	else if (strcmp("&Iacute;", str)==0)  { wort_plus_ch(205); } // capital I, acute accent 
	else if (strcmp("&Icirc;", str)==0)   { wort_plus_ch(206); } // capital I, circumflex accent 
	else if (strcmp("&Iuml;", str)==0)    { wort_plus_ch(207); } // capital I, dieresis or umlaut mark 
	else if (strcmp("&ETH;", str)==0)     { wort_plus_ch(208); } // capital Eth, Icelandic 
	else if (strcmp("&Ntilde;", str)==0)  { wort_plus_ch(209); } // capital N, tilde 
	else if (strcmp("&Ograve;", str)==0)  { wort_plus_ch(210); } // capital O, grave accent 
	else if (strcmp("&Oacute;", str)==0)  { wort_plus_ch(211); } // capital O, acute accent 
	else if (strcmp("&Ocirc;", str)==0)   { wort_plus_ch(212); } // capital O, circumflex accent 
	else if (strcmp("&Otilde;", str)==0)  { wort_plus_ch(213); } // capital O, tilde 
	else if (strcmp("&Ouml;", str)==0)    { wort_plus_ch(214); } // capital O, dieresis or umlaut mark 
	else if (strcmp("&times;", str)==0)   { wort_plus_ch(215); } // multiply sign 
	else if (strcmp("&Oslash;", str)==0)  { wort_plus_ch(216); } // capital O, slash 
	else if (strcmp("&Ugrave;", str)==0)  { wort_plus_ch(217); } // capital U, grave accent 
	else if (strcmp("&Uacute;", str)==0)  { wort_plus_ch(218); } // capital U, acute accent 
	else if (strcmp("&Ucirc;", str)==0)   { wort_plus_ch(219); } // capital U, circumflex accent 
	else if (strcmp("&Uuml;", str)==0)    { wort_plus_ch(220); } // capital U, dieresis or umlaut mark 
	else if (strcmp("&Yacute;", str)==0)  { wort_plus_ch(221); } // capital Y, acute accent 
	else if (strcmp("&THORN;", str)==0)   { wort_plus_ch(222); } // capital THORN, Icelandic 
	else if (strcmp("&szlig;", str)==0)   { wort_plus_ch(223); } // small sharp s, German (sz ligature) 
	else if (strcmp("&agrave;", str)==0)  { wort_plus_ch(224); } // small a, grave accent 
	else if (strcmp("&aacute;", str)==0)  { wort_plus_ch(225); } // small a, acute accent 
	else if (strcmp("&acirc;", str)==0)   { wort_plus_ch(226); } // small a, circumflex accent 
	else if (strcmp("&atilde;", str)==0)  { wort_plus_ch(227); } // small a, tilde 
	else if (strcmp("&auml;", str)==0)    { wort_plus_ch(228); } // small a, dieresis or umlaut mark 
	else if (strcmp("&aring;", str)==0)   { wort_plus_ch(229); } // small a, ring 
	else if (strcmp("&aelig;", str)==0)   { wort_plus_ch(230); } // small ae diphthong (ligature) 
	else if (strcmp("&ccedil;", str)==0)  { wort_plus_ch(231); } // small c, cedilla 
	else if (strcmp("&egrave;", str)==0)  { wort_plus_ch(232); } // small e, grave accent 
	else if (strcmp("&eacute;", str)==0)  { wort_plus_ch(233); } // small e, acute accent 
	else if (strcmp("&ecirc;", str)==0)   { wort_plus_ch(234); } // small e, circumflex accent 
	else if (strcmp("&euml;", str)==0)    { wort_plus_ch(235); } // small e, dieresis or umlaut mark 
	else if (strcmp("&igrave;", str)==0)  { wort_plus_ch(236); } // small i, grave accent 
	else if (strcmp("&iacute;", str)==0)  { wort_plus_ch(237); } // small i, acute accent 
	else if (strcmp("&icirc;", str)==0)   { wort_plus_ch(238); } // small i, circumflex accent 
	else if (strcmp("&iuml;", str)==0)    { wort_plus_ch(239); } // small i, dieresis or umlaut mark 
	else if (strcmp("&eth;", str)==0)     { wort_plus_ch(240); } // small eth, Icelandic 
	else if (strcmp("&ntilde;", str)==0)  { wort_plus_ch(241); } // small n, tilde 
	else if (strcmp("&ograve;", str)==0)  { wort_plus_ch(242); } // small o, grave accent 
	else if (strcmp("&oacute;", str)==0)  { wort_plus_ch(243); } // small o, acute accent 
	else if (strcmp("&ocirc;", str)==0)   { wort_plus_ch(244); } // small o, circumflex accent 
	else if (strcmp("&otilde;", str)==0)  { wort_plus_ch(245); } // small o, tilde 
	else if (strcmp("&ouml;", str)==0)    { wort_plus_ch(246); } // small o, dieresis or umlaut mark 
	else if (strcmp("&divide;", str)==0)  { wort_plus_ch(247); } // divide sign 
	else if (strcmp("&oslash;", str)==0)  { wort_plus_ch(248); } // small o, slash 
	else if (strcmp("&ugrave;", str)==0)  { wort_plus_ch(249); } // small u, grave accent 
	else if (strcmp("&uacute;", str)==0)  { wort_plus_ch(250); } // small u, acute accent 
	else if (strcmp("&ucirc;", str)==0)   { wort_plus_ch(251); } // small u, circumflex accent 
	else if (strcmp("&uuml;", str)==0)    { wort_plus_ch(252); } // small u, dieresis or umlaut mark 
	else if (strcmp("&yacute;", str)==0)  { wort_plus_ch(253); } // small y, acute accent 
	else if (strcmp("&thorn;", str)==0)   { wort_plus_ch(254); } // small thorn, Icelandic 
	else if (strcmp("&yuml;", str)==0)    { wort_plus_ch(255); } // small y, dieresis or umlaut mark 

	else { return(0); } // found no latin1 entity
	return(1); // found latin1 entity 
} // end latin1

/* ------------------------------------------------ */

void html()
{
  int i;
	char tmpstr[DEF_STR_LEN];
  align[0]=LEFT;

  for (;;)
  {
    ch = read_char();
#ifdef default_debug
    printf("default: ch=%c ; %d\n",ch,ch);
#endif

    switch (ch)
    {
      case '<':
#ifdef debug
        printf("<: \n");
#endif
        html_befehl();
        break;

      case '&':
#ifdef debug
        printf("&: \n");
#endif
        i=1;
        str[0] = ch;
        do
        {
          ch = read_char();
          str[i++] = ch;
        }
        while ((isalnum(ch)) || (ch=='#'));
				// wenn das letzte Zeichen kein ';' ist, ist das ganze kein valides Entity, aber vielleicht
				// was wie &nbsp oder sogar '& '
				if (ch!=';') 
				{ 
					// kein ';' am Schluss, kopiere ohne letztes Character 
					str[i-1] = '\0'; strcpy(tmpstr, str);
					// mach es zu einem validem Entitty
					str[i-1] = ';'; str[i] = '\0'; 
					// retten des letzten Elements
					goback_char(1); }  
				else 
				{
					// valides Entity, kopiere ganzes Element
					str[i] = '\0';
					strcpy(tmpstr, str);
				}
        
#ifdef debug
        printf("check &: %s\n",str);
#endif

 				if ((entity_number(str)) || (latin1(str)) || (microsoft_entities(str))) {} // if true entity was known
        else
        {
					if (errorlevel>=1) { printf("Entity %s unknown\n",tmpstr); }
					wort_plus_string(tmpstr);
					// FIXME MAYBE???
					//goback_char(strlen(str)-2);
					//wort_plus_ch(str[0]);
					//wort_plus_ch(str[1]);
				}
#ifdef debug
        printf("&: %s\n",str);
#endif
        break;

      case  9: // TAB */
      case 13: // CR */
#ifdef debug
        printf("TAB or CR\n");
#endif
      break;

      case '\n':
#ifdef debug
        printf("\\n: \n");
#endif
        wort_ende();
        if (pre) { line_break(); }
        break;

		  case EOF:
#ifdef debug
        printf("EOF: \n");
#endif
        quit();
        break;

      // Microsoft...
  		case 0x80: case 0x81: case 0x82: case 0x83: case 0x84: case 0x85: case 0x86: case 0x87: 
		  case 0x88: case 0x89: case 0x8a: case 0x8b: case 0x8c: case 0x8d:	case 0x8e: case 0x8f:
		  case 0x90: case 0x91: case 0x92: case 0x93: case 0x94: case 0x95: case 0x96: case 0x97:
      case 0x98: case 0x99: case 0x9a: case 0x9b: case 0x9c: case 0x9d: case 0x9e: case 0x9f:
				if (microsoft) { microsoft_character(ch); }
				else wort_plus_ch(ch);
				break;
		
      default:
#ifdef default_debug
        printf("default: ch=%c ; %d\n",ch,ch);
#endif
        if (pre==0)
        {
          if (ch==' ') { wort_ende(); }
          else { wort_plus_ch(ch); }
        }
        else { wort_plus_ch(ch); }
        break;
    }
  } /* next */
} /* end html */

/* ------------------------------------------------ */

void help()
{
	printf("\nUsage: vilistextum  [--palm] [--nomicrosoft] [--shrink-lines] [--remove-empty-alt] [--defimage string] [--width number] [--errorlevel number] [--convert-tags] inputfile outputfile\n");
	exit(20);
} // end help

/* ------------------------------------------------ */


void parse_args(int argc, char *argv[])
{
  int c;
  int digit_optind = 0;

  while (1)
  {
		int this_option_optind = optind ? optind : 1;
		int option_index = 0;
		static struct option long_options[] =
		{
			{"palm",  0, 0, 'p'},
			{"nomicrosoft", 0, 0, 'm'},
			{"shrink-lines", 0, 0, 's'},
			{"remove-empty-alt", 0, 0, 'r'},
			{"defimage", 1, 0, 'i'},
			{"width" , 1, 0, 'w'},
			{"convert-tags", 0, 0,'c'},
			{"errorlevel", 1, 0, 'e'},
			{"help", 0, 0, 'h'},
			{0, 0, 0, 0}
		};

		c = getopt_long (argc, argv, "pmsriwceh",
										 long_options, &option_index);
		if (c == -1)
			break;

		switch (c)
		{
		case 0:
			printf ("option %s", long_options[option_index].name);
			if (optarg)
				printf (" with arg %s", optarg);
			printf ("\n");
			break;

		case '0':
		case '1':
		case '2':
			if (digit_optind != 0 && digit_optind != this_option_optind)
				printf ("digits occur in two different argv-elements.\n");
			digit_optind = this_option_optind;
			printf ("option %c\n", c);
			break;

		case 'p':
      // Einstellungen fr PalmPilot
      hr_breite = 30;
      breite=DEF_STR_LEN; 
      palm = 1;
			break;
		case 'w': 
			breite = atoi(optarg); //argc--; argv++;
			hr_breite = breite;
			if (breite>DEF_STR_LEN) { printf("max(breite)=%d\n", DEF_STR_LEN); breite=DEF_STR_LEN; }
			break;
		case 'm': microsoft = 0; break;
		case 's': shrink_lines = 1;	break;
		case 'r': remove_empty_alt = 1; break;
		case 'i': default_image = optarg; /*argc--; argv++;*/ break;
		case 'c': convert_tags = 1; break;
		case 'e': errorlevel = atoi(optarg); /*argc--; argv++;*/ break;
		case 'h': help(); break;

		case '?': // unbekannte Option
			help();
			break;
					
		default:
          printf ("?? getopt returned character code 0%o %c??\n", c, c);
		}
	}
	/*                                                        
	if (optind < argc)
  {
		if (argc-optind!=2) { help(); }
		printf ("non-option ARGV-elements: ");
		while (optind < argc)
      printf ("%s ", argv[optind++]);
		printf ("\n");
	}
	*/
}                                

/* ------------------------------------------------ */

int main(int argc, char *argv[])
{
	parse_args(argc, argv);
	
  if (argc < 3) {	help(); }

	/*  while (argc > 3)
  {   
    if (strcmp(argv[1], "--palm")==0)
    {
      // Einstellungen fr PalmPilot
      hr_breite = 30;
      breite=DEF_STR_LEN; 
      palm = 1;
    }
		else if (strcmp(argv[1], "--width")==0) 
		{
			breite = atoi(argv[2]); argc--; argv++;
			hr_breite = breite;
			if (breite>DEF_STR_LEN) { printf("max(breite)=%d\n", DEF_STR_LEN); breite=DEF_STR_LEN; }
    }
    else if (strcmp(argv[1], "--convert-tags")==0) { convert_tags = 1; }
    else if (strcmp(argv[1], "--nomicrosoft")==0) { microsoft = 0; }
    else if (strcmp(argv[1], "--errorlevel")==0) { errorlevel = atoi(argv[2]); argc--; argv++; }
		else if (strcmp(argv[1], "--defimage")==0) { default_image = argv[2]; argc--; argv++; }
		else if (strcmp(argv[1], "--shrink-lines")==0) { shrink_lines = 1; }
		else if (strcmp(argv[1], "--remove-empty-alt")==0) { remove_empty_alt = 1; }

		else 
		{
			printf("Parsing error: %s\n", argv[1]);  
			help();
		}
    //printf("convert-tags %d, palm %d, argc %d argv[1] %s\n", convert_tags, palm, argc, argv[1]);

    argc--;
    argv++;
  }
	*/
  if ((in = fopen(argv[argc-2], "r"))==0)
  {
    printf("Couldn't open %s!\n",argv[argc-2]);
    exit(20);
  }
  if ((out = fopen(argv[argc-1], "w"))==0)
  {
    printf("Couldn't open %s!\n",argv[argc-1]);
    exit(20);
  }
  /*
  if (argc==4)

*/
  html();
  return 0;
} /* end main */
